Merge branch 'ao/merge-verbosity-getenv-just-once'
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built.  The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22         # We allow tests to override this, in case they want to run tests
23         # outside of t/, e.g. for running tests on the test library
24         # itself.
25         TEST_DIRECTORY=$(pwd)
26 else
27         # ensure that TEST_DIRECTORY is an absolute path so that it
28         # is valid even if the current working directory is changed
29         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33         # Similarly, override this to store the test-results subdir
34         # elsewhere
35         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 ################################################################
53 # It appears that people try to run tests without building...
54 "$GIT_BUILD_DIR/git" >/dev/null
55 if test $? != 1
56 then
57         echo >&2 'error: you do not seem to have built git yet.'
58         exit 1
59 fi
60
61 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
62 export PERL_PATH SHELL_PATH
63
64 # if --tee was passed, write the output not only to the terminal, but
65 # additionally to the file test-results/$BASENAME.out, too.
66 case "$GIT_TEST_TEE_STARTED, $* " in
67 done,*)
68         # do not redirect again
69         ;;
70 *' --tee '*|*' --va'*|*' --verbose-log '*)
71         mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
72         BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
73
74         # Make this filename available to the sub-process in case it is using
75         # --verbose-log.
76         GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
77         export GIT_TEST_TEE_OUTPUT_FILE
78
79         # Truncate before calling "tee -a" to get rid of the results
80         # from any previous runs.
81         >"$GIT_TEST_TEE_OUTPUT_FILE"
82
83         (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
84          echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
85         test "$(cat "$BASE.exit")" = 0
86         exit
87         ;;
88 esac
89
90 # For repeatability, reset the environment to known value.
91 # TERM is sanitized below, after saving color control sequences.
92 LANG=C
93 LC_ALL=C
94 PAGER=cat
95 TZ=UTC
96 export LANG LC_ALL PAGER TZ
97 EDITOR=:
98 # A call to "unset" with no arguments causes at least Solaris 10
99 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
100 # deriving from the command substitution clustered with the other
101 # ones.
102 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
103         my @env = keys %ENV;
104         my $ok = join("|", qw(
105                 TRACE
106                 DEBUG
107                 TEST
108                 .*_TEST
109                 PROVE
110                 VALGRIND
111                 UNZIP
112                 PERF_
113                 CURL_VERBOSE
114                 TRACE_CURL
115         ));
116         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
117         print join("\n", @vars);
118 ')
119 unset XDG_CONFIG_HOME
120 unset GITPERLLIB
121 GIT_AUTHOR_EMAIL=author@example.com
122 GIT_AUTHOR_NAME='A U Thor'
123 GIT_COMMITTER_EMAIL=committer@example.com
124 GIT_COMMITTER_NAME='C O Mitter'
125 GIT_MERGE_VERBOSITY=5
126 GIT_MERGE_AUTOEDIT=no
127 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
128 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
129 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
130 export EDITOR
131
132 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
133 GIT_TRACE_BARE=1
134 export GIT_TRACE_BARE
135
136 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
137 then
138         GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
139         export GIT_INDEX_VERSION
140 fi
141
142 # Add libc MALLOC and MALLOC_PERTURB test
143 # only if we are not executing the test with valgrind
144 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
145    test -n "$TEST_NO_MALLOC_CHECK"
146 then
147         setup_malloc_check () {
148                 : nothing
149         }
150         teardown_malloc_check () {
151                 : nothing
152         }
153 else
154         setup_malloc_check () {
155                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
156                 export MALLOC_CHECK_ MALLOC_PERTURB_
157         }
158         teardown_malloc_check () {
159                 unset MALLOC_CHECK_ MALLOC_PERTURB_
160         }
161 fi
162
163 # Protect ourselves from common misconfiguration to export
164 # CDPATH into the environment
165 unset CDPATH
166
167 unset GREP_OPTIONS
168 unset UNZIP
169
170 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
171 1|2|true)
172         GIT_TRACE=4
173         ;;
174 esac
175
176 # Convenience
177 #
178 # A regexp to match 5 and 40 hexdigits
179 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
180 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
181
182 # Zero SHA-1
183 _z40=0000000000000000000000000000000000000000
184
185 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
186 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
187
188 # Line feed
189 LF='
190 '
191
192 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
193 # when case-folding filenames
194 u200c=$(printf '\342\200\214')
195
196 export _x05 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB
197
198 # Each test should start with something like this, after copyright notices:
199 #
200 # test_description='Description of this test...
201 # This test checks if command xyzzy does the right thing...
202 # '
203 # . ./test-lib.sh
204 test "x$TERM" != "xdumb" && (
205                 test -t 1 &&
206                 tput bold >/dev/null 2>&1 &&
207                 tput setaf 1 >/dev/null 2>&1 &&
208                 tput sgr0 >/dev/null 2>&1
209         ) &&
210         color=t
211
212 while test "$#" -ne 0
213 do
214         case "$1" in
215         -d|--d|--de|--deb|--debu|--debug)
216                 debug=t; shift ;;
217         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
218                 immediate=t; shift ;;
219         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
220                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
221         -r)
222                 shift; test "$#" -ne 0 || {
223                         echo 'error: -r requires an argument' >&2;
224                         exit 1;
225                 }
226                 run_list=$1; shift ;;
227         --run=*)
228                 run_list=${1#--*=}; shift ;;
229         -h|--h|--he|--hel|--help)
230                 help=t; shift ;;
231         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
232                 verbose=t; shift ;;
233         --verbose-only=*)
234                 verbose_only=${1#--*=}
235                 shift ;;
236         -q|--q|--qu|--qui|--quie|--quiet)
237                 # Ignore --quiet under a TAP::Harness. Saying how many tests
238                 # passed without the ok/not ok details is always an error.
239                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
240         --with-dashes)
241                 with_dashes=t; shift ;;
242         --no-color)
243                 color=; shift ;;
244         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
245                 valgrind=memcheck
246                 shift ;;
247         --valgrind=*)
248                 valgrind=${1#--*=}
249                 shift ;;
250         --valgrind-only=*)
251                 valgrind_only=${1#--*=}
252                 shift ;;
253         --tee)
254                 shift ;; # was handled already
255         --root=*)
256                 root=${1#--*=}
257                 shift ;;
258         --chain-lint)
259                 GIT_TEST_CHAIN_LINT=1
260                 shift ;;
261         --no-chain-lint)
262                 GIT_TEST_CHAIN_LINT=0
263                 shift ;;
264         -x)
265                 trace=t
266                 verbose=t
267                 shift ;;
268         --verbose-log)
269                 verbose_log=t
270                 shift ;;
271         *)
272                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
273         esac
274 done
275
276 if test -n "$valgrind_only"
277 then
278         test -z "$valgrind" && valgrind=memcheck
279         test -z "$verbose" && verbose_only="$valgrind_only"
280 elif test -n "$valgrind"
281 then
282         test -z "$verbose_log" && verbose=t
283 fi
284
285 if test -n "$color"
286 then
287         # Save the color control sequences now rather than run tput
288         # each time say_color() is called.  This is done for two
289         # reasons:
290         #   * TERM will be changed to dumb
291         #   * HOME will be changed to a temporary directory and tput
292         #     might need to read ~/.terminfo from the original HOME
293         #     directory to get the control sequences
294         # Note:  This approach assumes the control sequences don't end
295         # in a newline for any terminal of interest (command
296         # substitutions strip trailing newlines).  Given that most
297         # (all?) terminals in common use are related to ECMA-48, this
298         # shouldn't be a problem.
299         say_color_error=$(tput bold; tput setaf 1) # bold red
300         say_color_skip=$(tput setaf 4) # blue
301         say_color_warn=$(tput setaf 3) # brown/yellow
302         say_color_pass=$(tput setaf 2) # green
303         say_color_info=$(tput setaf 6) # cyan
304         say_color_reset=$(tput sgr0)
305         say_color_="" # no formatting for normal text
306         say_color () {
307                 test -z "$1" && test -n "$quiet" && return
308                 eval "say_color_color=\$say_color_$1"
309                 shift
310                 printf "%s\\n" "$say_color_color$*$say_color_reset"
311         }
312 else
313         say_color() {
314                 test -z "$1" && test -n "$quiet" && return
315                 shift
316                 printf "%s\n" "$*"
317         }
318 fi
319
320 TERM=dumb
321 export TERM
322
323 error () {
324         say_color error "error: $*"
325         GIT_EXIT_OK=t
326         exit 1
327 }
328
329 say () {
330         say_color info "$*"
331 }
332
333 if test -n "$HARNESS_ACTIVE"
334 then
335         if test "$verbose" = t || test -n "$verbose_only"
336         then
337                 printf 'Bail out! %s\n' \
338                  'verbose mode forbidden under TAP harness; try --verbose-log'
339                 exit 1
340         fi
341 fi
342
343 test "${test_description}" != "" ||
344 error "Test script did not set test_description."
345
346 if test "$help" = "t"
347 then
348         printf '%s\n' "$test_description"
349         exit 0
350 fi
351
352 exec 5>&1
353 exec 6<&0
354 exec 7>&2
355 if test "$verbose_log" = "t"
356 then
357         exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
358 elif test "$verbose" = "t"
359 then
360         exec 4>&2 3>&1
361 else
362         exec 4>/dev/null 3>/dev/null
363 fi
364
365 # Send any "-x" output directly to stderr to avoid polluting tests
366 # which capture stderr. We can do this unconditionally since it
367 # has no effect if tracing isn't turned on.
368 #
369 # Note that this sets up the trace fd as soon as we assign the variable, so it
370 # must come after the creation of descriptor 4 above. Likewise, we must never
371 # unset this, as it has the side effect of closing descriptor 4, which we
372 # use to show verbose tests to the user.
373 #
374 # Note also that we don't need or want to export it. The tracing is local to
375 # this shell, and we would not want to influence any shells we exec.
376 BASH_XTRACEFD=4
377
378 test_failure=0
379 test_count=0
380 test_fixed=0
381 test_broken=0
382 test_success=0
383
384 test_external_has_tap=0
385
386 die () {
387         code=$?
388         if test -n "$GIT_EXIT_OK"
389         then
390                 exit $code
391         else
392                 echo >&5 "FATAL: Unexpected exit with code $code"
393                 exit 1
394         fi
395 }
396
397 GIT_EXIT_OK=
398 trap 'die' EXIT
399 trap 'exit $?' INT
400
401 # The user-facing functions are loaded from a separate file so that
402 # test_perf subshells can have them too
403 . "$TEST_DIRECTORY/test-lib-functions.sh"
404
405 # You are not expected to call test_ok_ and test_failure_ directly, use
406 # the test_expect_* functions instead.
407
408 test_ok_ () {
409         test_success=$(($test_success + 1))
410         say_color "" "ok $test_count - $@"
411 }
412
413 test_failure_ () {
414         test_failure=$(($test_failure + 1))
415         say_color error "not ok $test_count - $1"
416         shift
417         printf '%s\n' "$*" | sed -e 's/^/#      /'
418         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
419 }
420
421 test_known_broken_ok_ () {
422         test_fixed=$(($test_fixed+1))
423         say_color error "ok $test_count - $@ # TODO known breakage vanished"
424 }
425
426 test_known_broken_failure_ () {
427         test_broken=$(($test_broken+1))
428         say_color warn "not ok $test_count - $@ # TODO known breakage"
429 }
430
431 test_debug () {
432         test "$debug" = "" || eval "$1"
433 }
434
435 match_pattern_list () {
436         arg="$1"
437         shift
438         test -z "$*" && return 1
439         for pattern_
440         do
441                 case "$arg" in
442                 $pattern_)
443                         return 0
444                 esac
445         done
446         return 1
447 }
448
449 match_test_selector_list () {
450         title="$1"
451         shift
452         arg="$1"
453         shift
454         test -z "$1" && return 0
455
456         # Both commas and whitespace are accepted as separators.
457         OLDIFS=$IFS
458         IFS='   ,'
459         set -- $1
460         IFS=$OLDIFS
461
462         # If the first selector is negative we include by default.
463         include=
464         case "$1" in
465                 !*) include=t ;;
466         esac
467
468         for selector
469         do
470                 orig_selector=$selector
471
472                 positive=t
473                 case "$selector" in
474                         !*)
475                                 positive=
476                                 selector=${selector##?}
477                                 ;;
478                 esac
479
480                 test -z "$selector" && continue
481
482                 case "$selector" in
483                         *-*)
484                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
485                                 then
486                                         echo "error: $title: invalid non-numeric in range" \
487                                                 "start: '$orig_selector'" >&2
488                                         exit 1
489                                 fi
490                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
491                                 then
492                                         echo "error: $title: invalid non-numeric in range" \
493                                                 "end: '$orig_selector'" >&2
494                                         exit 1
495                                 fi
496                                 ;;
497                         *)
498                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
499                                 then
500                                         echo "error: $title: invalid non-numeric in test" \
501                                                 "selector: '$orig_selector'" >&2
502                                         exit 1
503                                 fi
504                 esac
505
506                 # Short cut for "obvious" cases
507                 test -z "$include" && test -z "$positive" && continue
508                 test -n "$include" && test -n "$positive" && continue
509
510                 case "$selector" in
511                         -*)
512                                 if test $arg -le ${selector#-}
513                                 then
514                                         include=$positive
515                                 fi
516                                 ;;
517                         *-)
518                                 if test $arg -ge ${selector%-}
519                                 then
520                                         include=$positive
521                                 fi
522                                 ;;
523                         *-*)
524                                 if test ${selector%%-*} -le $arg \
525                                         && test $arg -le ${selector#*-}
526                                 then
527                                         include=$positive
528                                 fi
529                                 ;;
530                         *)
531                                 if test $arg -eq $selector
532                                 then
533                                         include=$positive
534                                 fi
535                                 ;;
536                 esac
537         done
538
539         test -n "$include"
540 }
541
542 maybe_teardown_verbose () {
543         test -z "$verbose_only" && return
544         exec 4>/dev/null 3>/dev/null
545         verbose=
546 }
547
548 last_verbose=t
549 maybe_setup_verbose () {
550         test -z "$verbose_only" && return
551         if match_pattern_list $test_count $verbose_only
552         then
553                 exec 4>&2 3>&1
554                 # Emit a delimiting blank line when going from
555                 # non-verbose to verbose.  Within verbose mode the
556                 # delimiter is printed by test_expect_*.  The choice
557                 # of the initial $last_verbose is such that before
558                 # test 1, we do not print it.
559                 test -z "$last_verbose" && echo >&3 ""
560                 verbose=t
561         else
562                 exec 4>/dev/null 3>/dev/null
563                 verbose=
564         fi
565         last_verbose=$verbose
566 }
567
568 maybe_teardown_valgrind () {
569         test -z "$GIT_VALGRIND" && return
570         GIT_VALGRIND_ENABLED=
571 }
572
573 maybe_setup_valgrind () {
574         test -z "$GIT_VALGRIND" && return
575         if test -z "$valgrind_only"
576         then
577                 GIT_VALGRIND_ENABLED=t
578                 return
579         fi
580         GIT_VALGRIND_ENABLED=
581         if match_pattern_list $test_count $valgrind_only
582         then
583                 GIT_VALGRIND_ENABLED=t
584         fi
585 }
586
587 want_trace () {
588         test "$trace" = t && test "$verbose" = t
589 }
590
591 # This is a separate function because some tests use
592 # "return" to end a test_expect_success block early
593 # (and we want to make sure we run any cleanup like
594 # "set +x").
595 test_eval_inner_ () {
596         # Do not add anything extra (including LF) after '$*'
597         eval "
598                 want_trace && set -x
599                 $*"
600 }
601
602 test_eval_ () {
603         # We run this block with stderr redirected to avoid extra cruft
604         # during a "-x" trace. Once in "set -x" mode, we cannot prevent
605         # the shell from printing the "set +x" to turn it off (nor the saving
606         # of $? before that). But we can make sure that the output goes to
607         # /dev/null.
608         #
609         # The test itself is run with stderr put back to &4 (so either to
610         # /dev/null, or to the original stderr if --verbose was used).
611         {
612                 test_eval_inner_ "$@" </dev/null >&3 2>&4
613                 test_eval_ret_=$?
614                 if want_trace
615                 then
616                         set +x
617                         if test "$test_eval_ret_" != 0
618                         then
619                                 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
620                         fi
621                 fi
622         } 2>/dev/null
623         return $test_eval_ret_
624 }
625
626 test_run_ () {
627         test_cleanup=:
628         expecting_failure=$2
629
630         if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
631                 # turn off tracing for this test-eval, as it simply creates
632                 # confusing noise in the "-x" output
633                 trace_tmp=$trace
634                 trace=
635                 # 117 is magic because it is unlikely to match the exit
636                 # code of other programs
637                 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
638                 then
639                         error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
640                 fi
641                 trace=$trace_tmp
642         fi
643
644         setup_malloc_check
645         test_eval_ "$1"
646         eval_ret=$?
647         teardown_malloc_check
648
649         if test -z "$immediate" || test $eval_ret = 0 ||
650            test -n "$expecting_failure" && test "$test_cleanup" != ":"
651         then
652                 setup_malloc_check
653                 test_eval_ "$test_cleanup"
654                 teardown_malloc_check
655         fi
656         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
657         then
658                 echo ""
659         fi
660         return "$eval_ret"
661 }
662
663 test_start_ () {
664         test_count=$(($test_count+1))
665         maybe_setup_verbose
666         maybe_setup_valgrind
667 }
668
669 test_finish_ () {
670         echo >&3 ""
671         maybe_teardown_valgrind
672         maybe_teardown_verbose
673 }
674
675 test_skip () {
676         to_skip=
677         skipped_reason=
678         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
679         then
680                 to_skip=t
681                 skipped_reason="GIT_SKIP_TESTS"
682         fi
683         if test -z "$to_skip" && test -n "$test_prereq" &&
684            ! test_have_prereq "$test_prereq"
685         then
686                 to_skip=t
687
688                 of_prereq=
689                 if test "$missing_prereq" != "$test_prereq"
690                 then
691                         of_prereq=" of $test_prereq"
692                 fi
693                 skipped_reason="missing $missing_prereq${of_prereq}"
694         fi
695         if test -z "$to_skip" && test -n "$run_list" &&
696                 ! match_test_selector_list '--run' $test_count "$run_list"
697         then
698                 to_skip=t
699                 skipped_reason="--run"
700         fi
701
702         case "$to_skip" in
703         t)
704                 say_color skip >&3 "skipping test: $@"
705                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
706                 : true
707                 ;;
708         *)
709                 false
710                 ;;
711         esac
712 }
713
714 # stub; perf-lib overrides it
715 test_at_end_hook_ () {
716         :
717 }
718
719 test_done () {
720         GIT_EXIT_OK=t
721
722         if test -z "$HARNESS_ACTIVE"
723         then
724                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
725                 mkdir -p "$test_results_dir"
726                 base=${0##*/}
727                 test_results_path="$test_results_dir/${base%.sh}.counts"
728
729                 cat >"$test_results_path" <<-EOF
730                 total $test_count
731                 success $test_success
732                 fixed $test_fixed
733                 broken $test_broken
734                 failed $test_failure
735
736                 EOF
737         fi
738
739         if test "$test_fixed" != 0
740         then
741                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
742         fi
743         if test "$test_broken" != 0
744         then
745                 say_color warn "# still have $test_broken known breakage(s)"
746         fi
747         if test "$test_broken" != 0 || test "$test_fixed" != 0
748         then
749                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
750                 msg="remaining $test_remaining test(s)"
751         else
752                 test_remaining=$test_count
753                 msg="$test_count test(s)"
754         fi
755         case "$test_failure" in
756         0)
757                 if test $test_external_has_tap -eq 0
758                 then
759                         if test $test_remaining -gt 0
760                         then
761                                 say_color pass "# passed all $msg"
762                         fi
763
764                         # Maybe print SKIP message
765                         test -z "$skip_all" || skip_all="# SKIP $skip_all"
766                         case "$test_count" in
767                         0)
768                                 say "1..$test_count${skip_all:+ $skip_all}"
769                                 ;;
770                         *)
771                                 test -z "$skip_all" ||
772                                 say_color warn "$skip_all"
773                                 say "1..$test_count"
774                                 ;;
775                         esac
776                 fi
777
778                 if test -z "$debug"
779                 then
780                         test -d "$TRASH_DIRECTORY" ||
781                         error "Tests passed but trash directory already removed before test cleanup; aborting"
782
783                         cd "$TRASH_DIRECTORY/.." &&
784                         rm -fr "$TRASH_DIRECTORY" ||
785                         error "Tests passed but test cleanup failed; aborting"
786                 fi
787                 test_at_end_hook_
788
789                 exit 0 ;;
790
791         *)
792                 if test $test_external_has_tap -eq 0
793                 then
794                         say_color error "# failed $test_failure among $msg"
795                         say "1..$test_count"
796                 fi
797
798                 exit 1 ;;
799
800         esac
801 }
802
803 if test -n "$valgrind"
804 then
805         make_symlink () {
806                 test -h "$2" &&
807                 test "$1" = "$(readlink "$2")" || {
808                         # be super paranoid
809                         if mkdir "$2".lock
810                         then
811                                 rm -f "$2" &&
812                                 ln -s "$1" "$2" &&
813                                 rm -r "$2".lock
814                         else
815                                 while test -d "$2".lock
816                                 do
817                                         say "Waiting for lock on $2."
818                                         sleep 1
819                                 done
820                         fi
821                 }
822         }
823
824         make_valgrind_symlink () {
825                 # handle only executables, unless they are shell libraries that
826                 # need to be in the exec-path.
827                 test -x "$1" ||
828                 test "# " = "$(head -c 2 <"$1")" ||
829                 return;
830
831                 base=$(basename "$1")
832                 case "$base" in
833                 test-*)
834                         symlink_target="$GIT_BUILD_DIR/t/helper/$base"
835                         ;;
836                 *)
837                         symlink_target="$GIT_BUILD_DIR/$base"
838                         ;;
839                 esac
840                 # do not override scripts
841                 if test -x "$symlink_target" &&
842                     test ! -d "$symlink_target" &&
843                     test "#!" != "$(head -c 2 < "$symlink_target")"
844                 then
845                         symlink_target=../valgrind.sh
846                 fi
847                 case "$base" in
848                 *.sh|*.perl)
849                         symlink_target=../unprocessed-script
850                 esac
851                 # create the link, or replace it if it is out of date
852                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
853         }
854
855         # override all git executables in TEST_DIRECTORY/..
856         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
857         mkdir -p "$GIT_VALGRIND"/bin
858         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
859         do
860                 make_valgrind_symlink $file
861         done
862         # special-case the mergetools loadables
863         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
864         OLDIFS=$IFS
865         IFS=:
866         for path in $PATH
867         do
868                 ls "$path"/git-* 2> /dev/null |
869                 while read file
870                 do
871                         make_valgrind_symlink "$file"
872                 done
873         done
874         IFS=$OLDIFS
875         PATH=$GIT_VALGRIND/bin:$PATH
876         GIT_EXEC_PATH=$GIT_VALGRIND/bin
877         export GIT_VALGRIND
878         GIT_VALGRIND_MODE="$valgrind"
879         export GIT_VALGRIND_MODE
880         GIT_VALGRIND_ENABLED=t
881         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
882         export GIT_VALGRIND_ENABLED
883 elif test -n "$GIT_TEST_INSTALLED"
884 then
885         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
886         error "Cannot run git from $GIT_TEST_INSTALLED."
887         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
888         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
889 else # normal case, use ../bin-wrappers only unless $with_dashes:
890         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
891         if ! test -x "$git_bin_dir/git"
892         then
893                 if test -z "$with_dashes"
894                 then
895                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
896                 fi
897                 with_dashes=t
898         fi
899         PATH="$git_bin_dir:$PATH"
900         GIT_EXEC_PATH=$GIT_BUILD_DIR
901         if test -n "$with_dashes"
902         then
903                 PATH="$GIT_BUILD_DIR:$PATH"
904         fi
905 fi
906 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
907 GIT_CONFIG_NOSYSTEM=1
908 GIT_ATTR_NOSYSTEM=1
909 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
910
911 if test -z "$GIT_TEST_CMP"
912 then
913         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
914         then
915                 GIT_TEST_CMP="$DIFF -c"
916         else
917                 GIT_TEST_CMP="$DIFF -u"
918         fi
919 fi
920
921 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
922 export GITPERLLIB
923 test -d "$GIT_BUILD_DIR"/templates/blt || {
924         error "You haven't built things yet, have you?"
925 }
926
927 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-chmtime
928 then
929         echo >&2 'You need to build test-chmtime:'
930         echo >&2 'Run "make t/helper/test-chmtime" in the source (toplevel) directory'
931         exit 1
932 fi
933
934 # Test repository
935 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
936 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
937 case "$TRASH_DIRECTORY" in
938 /*) ;; # absolute path is good
939  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
940 esac
941 rm -fr "$TRASH_DIRECTORY" || {
942         GIT_EXIT_OK=t
943         echo >&5 "FATAL: Cannot prepare test area"
944         exit 1
945 }
946
947 HOME="$TRASH_DIRECTORY"
948 GNUPGHOME="$HOME/gnupg-home-not-used"
949 export HOME GNUPGHOME
950
951 if test -z "$TEST_NO_CREATE_REPO"
952 then
953         test_create_repo "$TRASH_DIRECTORY"
954 else
955         mkdir -p "$TRASH_DIRECTORY"
956 fi
957 # Use -P to resolve symlinks in our working directory so that the cwd
958 # in subprocesses like git equals our $PWD (for pathname comparisons).
959 cd -P "$TRASH_DIRECTORY" || exit 1
960
961 this_test=${0##*/}
962 this_test=${this_test%%-*}
963 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
964 then
965         say_color info >&3 "skipping test $this_test altogether"
966         skip_all="skip all tests in $this_test"
967         test_done
968 fi
969
970 # Provide an implementation of the 'yes' utility
971 yes () {
972         if test $# = 0
973         then
974                 y=y
975         else
976                 y="$*"
977         fi
978
979         i=0
980         while test $i -lt 99
981         do
982                 echo "$y"
983                 i=$(($i+1))
984         done
985 }
986
987 # Fix some commands on Windows
988 uname_s=$(uname -s)
989 case $uname_s in
990 *MINGW*)
991         # Windows has its own (incompatible) sort and find
992         sort () {
993                 /usr/bin/sort "$@"
994         }
995         find () {
996                 /usr/bin/find "$@"
997         }
998         # git sees Windows-style pwd
999         pwd () {
1000                 builtin pwd -W
1001         }
1002         # no POSIX permissions
1003         # backslashes in pathspec are converted to '/'
1004         # exec does not inherit the PID
1005         test_set_prereq MINGW
1006         test_set_prereq NATIVE_CRLF
1007         test_set_prereq SED_STRIPS_CR
1008         test_set_prereq GREP_STRIPS_CR
1009         GIT_TEST_CMP=mingw_test_cmp
1010         ;;
1011 *CYGWIN*)
1012         test_set_prereq POSIXPERM
1013         test_set_prereq EXECKEEPSPID
1014         test_set_prereq CYGWIN
1015         test_set_prereq SED_STRIPS_CR
1016         test_set_prereq GREP_STRIPS_CR
1017         ;;
1018 *)
1019         test_set_prereq POSIXPERM
1020         test_set_prereq BSLASHPSPEC
1021         test_set_prereq EXECKEEPSPID
1022         ;;
1023 esac
1024
1025 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1026 test -z "$NO_PERL" && test_set_prereq PERL
1027 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1028 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1029 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1030 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1031
1032 # Can we rely on git's output in the C locale?
1033 if test -n "$GETTEXT_POISON"
1034 then
1035         GIT_GETTEXT_POISON=YesPlease
1036         export GIT_GETTEXT_POISON
1037         test_set_prereq GETTEXT_POISON
1038 else
1039         test_set_prereq C_LOCALE_OUTPUT
1040 fi
1041
1042 # Use this instead of test_cmp to compare files that contain expected and
1043 # actual output from git commands that can be translated.  When running
1044 # under GETTEXT_POISON this pretends that the command produced expected
1045 # results.
1046 test_i18ncmp () {
1047         test -n "$GETTEXT_POISON" || test_cmp "$@"
1048 }
1049
1050 # Use this instead of "grep expected-string actual" to see if the
1051 # output from a git command that can be translated either contains an
1052 # expected string, or does not contain an unwanted one.  When running
1053 # under GETTEXT_POISON this pretends that the command produced expected
1054 # results.
1055 test_i18ngrep () {
1056         if test -n "$GETTEXT_POISON"
1057         then
1058             : # pretend success
1059         elif test "x!" = "x$1"
1060         then
1061                 shift
1062                 ! grep "$@"
1063         else
1064                 grep "$@"
1065         fi
1066 }
1067
1068 test_lazy_prereq PIPE '
1069         # test whether the filesystem supports FIFOs
1070         test_have_prereq !MINGW,!CYGWIN &&
1071         rm -f testfifo && mkfifo testfifo
1072 '
1073
1074 test_lazy_prereq SYMLINKS '
1075         # test whether the filesystem supports symbolic links
1076         ln -s x y && test -h y
1077 '
1078
1079 test_lazy_prereq FILEMODE '
1080         test "$(git config --bool core.filemode)" = true
1081 '
1082
1083 test_lazy_prereq CASE_INSENSITIVE_FS '
1084         echo good >CamelCase &&
1085         echo bad >camelcase &&
1086         test "$(cat CamelCase)" != good
1087 '
1088
1089 test_lazy_prereq UTF8_NFD_TO_NFC '
1090         # check whether FS converts nfd unicode to nfc
1091         auml=$(printf "\303\244")
1092         aumlcdiar=$(printf "\141\314\210")
1093         >"$auml" &&
1094         case "$(echo *)" in
1095         "$aumlcdiar")
1096                 true ;;
1097         *)
1098                 false ;;
1099         esac
1100 '
1101
1102 test_lazy_prereq AUTOIDENT '
1103         sane_unset GIT_AUTHOR_NAME &&
1104         sane_unset GIT_AUTHOR_EMAIL &&
1105         git var GIT_AUTHOR_IDENT
1106 '
1107
1108 test_lazy_prereq EXPENSIVE '
1109         test -n "$GIT_TEST_LONG"
1110 '
1111
1112 test_lazy_prereq USR_BIN_TIME '
1113         test -x /usr/bin/time
1114 '
1115
1116 test_lazy_prereq NOT_ROOT '
1117         uid=$(id -u) &&
1118         test "$uid" != 0
1119 '
1120
1121 test_lazy_prereq JGIT '
1122         type jgit
1123 '
1124
1125 # SANITY is about "can you correctly predict what the filesystem would
1126 # do by only looking at the permission bits of the files and
1127 # directories?"  A typical example of !SANITY is running the test
1128 # suite as root, where a test may expect "chmod -r file && cat file"
1129 # to fail because file is supposed to be unreadable after a successful
1130 # chmod.  In an environment (i.e. combination of what filesystem is
1131 # being used and who is running the tests) that lacks SANITY, you may
1132 # be able to delete or create a file when the containing directory
1133 # doesn't have write permissions, or access a file even if the
1134 # containing directory doesn't have read or execute permissions.
1135
1136 test_lazy_prereq SANITY '
1137         mkdir SANETESTD.1 SANETESTD.2 &&
1138
1139         chmod +w SANETESTD.1 SANETESTD.2 &&
1140         >SANETESTD.1/x 2>SANETESTD.2/x &&
1141         chmod -w SANETESTD.1 &&
1142         chmod -r SANETESTD.1/x &&
1143         chmod -rx SANETESTD.2 ||
1144         error "bug in test sript: cannot prepare SANETESTD"
1145
1146         ! test -r SANETESTD.1/x &&
1147         ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1148         status=$?
1149
1150         chmod +rwx SANETESTD.1 SANETESTD.2 &&
1151         rm -rf SANETESTD.1 SANETESTD.2 ||
1152         error "bug in test sript: cannot clean SANETESTD"
1153         return $status
1154 '
1155
1156 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1157 GIT_UNZIP=${GIT_UNZIP:-unzip}
1158 test_lazy_prereq UNZIP '
1159         "$GIT_UNZIP" -v
1160         test $? -ne 127
1161 '
1162
1163 run_with_limited_cmdline () {
1164         (ulimit -s 128 && "$@")
1165 }
1166
1167 test_lazy_prereq CMDLINE_LIMIT '
1168         test_have_prereq !MINGW,!CYGWIN &&
1169         run_with_limited_cmdline true
1170 '
1171
1172 run_with_limited_stack () {
1173         (ulimit -s 128 && "$@")
1174 }
1175
1176 test_lazy_prereq ULIMIT_STACK_SIZE '
1177         test_have_prereq !MINGW,!CYGWIN &&
1178         run_with_limited_stack true
1179 '
1180
1181 build_option () {
1182         git version --build-options |
1183         sed -ne "s/^$1: //p"
1184 }
1185
1186 test_lazy_prereq LONG_IS_64BIT '
1187         test 8 -le "$(build_option sizeof-long)"
1188 '
1189
1190 test_lazy_prereq TIME_IS_64BIT 'test-date is64bit'
1191 test_lazy_prereq TIME_T_IS_64BIT 'test-date time_t-is64bit'